/***************************************************************************
                          scatterplot.cpp  -  description
                             -------------------
    begin                : Sun May 11 2003
    copyright            : (C) 2003 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "scatterplot.h"

#include <qpainter.h>

#include "fungmath.h"
#include "statinfo.h"

ScatterPlot::ScatterPlot(std::vector<double> & xlist, std::vector<double> & ylist, bool show, const QColor & color) :
	PlotModule(show,color),
	_xlist(xlist),
	_ylist(ylist)
{}

void ScatterPlot::drawPlot( QPainter *painter, int *, StatPlotGraph *graph, double, double )
{
	int min = (int)StatInfo::smaller(_xlist.size(),_ylist.size());

	for (int i=0; i<min; i++)
	{
		painter->drawRect(
			toPixelXCoord(graph,_xlist[i])-SCATTERWIDTH/2,
			toPixelYCoord(graph,_ylist[i])-SCATTERHEIGHT/2,
			SCATTERWIDTH,
			SCATTERHEIGHT
		);
	}
}

void ScatterPlot::trace( double, double, double *, double * )
{
	qDebug("Trace not implemented");
}

std::string ScatterPlot::updateCoords( double, double )
{
	return std::string("");
}

void ScatterPlot::zoomStat( double *xmin, double *xmax, double *ymin, double *ymax )
{
	int points = (int)StatInfo::smaller(_xlist.size(),_ylist.size());
	if (points == 0) return;

	double xMin = _xlist[0];
	double xMax = _xlist[0];
	double yMin = _ylist[0];
	double yMax = _ylist[0];

	for (int i=1; i<points; i++)
	{
		xMin = StatInfo::smaller(xMin,_xlist[i]);
		xMax = StatInfo::bigger(xMax,_xlist[i]);
		yMin = StatInfo::smaller(yMin,_ylist[i]);
		yMax = StatInfo::bigger(yMax,_ylist[i]);
	}

	*xmin = xMin-1;
	*xmax = xMax+1;
	*ymin = yMin-1;
	*ymax = yMax+1;
}
