/***************************************************************************
                          glcylindricalgraph.h  -  description
                             -------------------
    begin                : Mon Dec 2 2002
    copyright            : (C) 2002 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GLCYLINDRICALGRAPH_H
#define GLCYLINDRICALGRAPH_H

#include "glexpressiongraph.h"

/**
  *@author Fungmeista
  */

class GLCylindricalGraph : public GLExpressionGraph  {
	Q_OBJECT

	public: 
		GLCylindricalGraph(QWidget *parent=0, const char *name=0);
		~GLCylindricalGraph();

		int setThetaMin(double);
		int setThetaMax(double);
		int setRadiusMin(double);
		int setRadiusMax(double);

		GLfloat getThetaMin() const{return thetaMin;}
		GLfloat getThetaMax() const{return thetaMax;}
		GLfloat getRadiusMin() const{return radiusMin;}
		GLfloat getRadiusMax() const{return radiusMax;}
		
		virtual inline int getGraphType() const{return GLCYLINDRICALGRAPH;}

	protected:
		virtual const char * independent_vars() const{return "r,t";}
		virtual const char * dependent_var() const{return "z";}
		void trace(GLfloat mouseX, GLfloat mouseY, FungParser &parsed_function, GLfloat *x, GLfloat *y, GLfloat *z);

		inline virtual GLfloat traceDepX(GLfloat x) const{return (x-getXMin())/((getXMax()-getXMin())/(radiusMax-radiusMin))+radiusMin;}
		inline virtual GLfloat traceDepY(GLfloat y) const{return (y-getYMin())/((getYMax()-getYMin())/(thetaMax-thetaMin))+thetaMin;}

		virtual Cartesian3DCoord2DVector getValues( FungParser &fp, GLfloat *, GLfloat * );

	private:
		GLfloat thetaMin,thetaMax,radiusMin,radiusMax;

};

#endif
