/***************************************************************************
                          glfunctiongraph.cpp  -  description
                             -------------------
    begin                : Fri Oct 18 2002
    copyright            : (C) 2002-03 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "glfunctiongraph.h"

#include "fungparser.h"
#include "fungmath.h"

GLFunctionGraph::GLFunctionGraph(QWidget *parent, const char *name) : GLExpressionGraph(parent,name)
{
}

GLFunctionGraph::~GLFunctionGraph()
{
}

void GLFunctionGraph::trace(GLfloat mouseX, GLfloat mouseY, FungParser &parser, GLfloat *x, GLfloat *y, GLfloat *z)
{
	double values[] = {mouseX,mouseY,animatorValue()};
	GLfloat _z = parser.Eval(values);

	emit activeCoordinateChanged(QString("x = %1").arg(mouseX),QString("y = %1").arg(mouseY),QString("z = %1").arg(_z));
        
	*x = mouseX;
	*y = mouseY;
	*z = _z;
}

std::vector< std::vector<Cartesian3DCoord> > GLFunctionGraph::getValues( FungParser &fp, GLfloat *min, GLfloat *max )
{
	qDebug("GLFunctionGraph::getValues()");
	Cartesian3DCoord2DVector values;

	GLfloat x, y, z, current_min = 0.0, current_max = 0.0;
	int x_index, y_index;
	for (x = getXMin(), x_index = 0; x < getXMax() - xScale; x_index++, x+=xScale)
	{
		values.push_back( std::vector<Cartesian3DCoord>() );
		for (y = getYMin(), y_index = 0; y < getYMax() - yScale; y_index++, y+=yScale)
		{
			double d[] = {x,y,animatorValue()};
			z = fp.Eval(d);
			
			current_min = MIN(current_min,z);
			current_max = MAX(current_max,z);

			values[x_index].push_back( Cartesian3DCoord(x,y,z) );
		}
	}

	if ( min != 0 )
		*min = current_min;
	if ( max != 0 )
		*max = current_max;

	return values;
}


