/***************************************************************************
                          cartesian3dcoord.cpp  -  description
                             -------------------
    begin                : Sat Nov 30 2002
    copyright            : (C) 2002 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 
#include <cmath>                

#include "cartesian3dcoord.h"
#include "sphericalcoord.h"

Cartesian3DCoord::Cartesian3DCoord(double x, double y, double z) : _x(x), _y(y), _z(z)
{                                                       
}                                                            

SphericalCoord Cartesian3DCoord::toSphericalCoord()
{
	double azimuthal, polar, radial;             

	azimuthal = atan2(_y,_x);
	radial = sqrt(_x*_x+_y*_y+_z*_z);
	polar = acos(_z/radial);

	return SphericalCoord(azimuthal,polar,radial);
}
