/***************************************************************************
                          expression.cpp  -  description
                             -------------------
    begin                : Wed Oct 9 2002
    copyright            : (C) 2002-2003 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "expression.h"

#include "fungparser.h"

Expression::Expression(const Expression &e) :
	show(e.show),
	color(e.color),
	#ifdef GLGRAPH
	name(e.name),
	#endif //GLGRAPH
	deleteable(false),
	expression1(e.expression1),
	expression2(e.expression2),
	parsedExpression(e.parsedExpression),
	parsedExpression2(e.parsedExpression2)
{}

Expression::Expression(const char * _expression, bool _show, QColor _color) :
	show(_show), color(_color),
	deleteable(false),
	expression1(_expression),
	parsedExpression(0),
	parsedExpression2(0)
{}

Expression::Expression(const char * _expression2, const char * _expression1, bool _show, QColor _color) :
	show(_show),
	color(_color),	
	deleteable(false),
	expression1(_expression1), 
	expression2(_expression2),
	parsedExpression(0),
	parsedExpression2(0)
{}

#ifdef GLGRAPH
Expression::Expression(std::string & expression, bool _show, QColor _color, GLuint _name) :
	show(_show),
	color(_color),
	name(_name),	
	deleteable(true),
	expression1(expression),
	parsedExpression(0),
	parsedExpression2(0)
{}
#endif //GLGRAPH

Expression::~Expression()
{

	if (deleteable)
	{
		if (parsedExpression)
			delete parsedExpression;
		if (parsedExpression2)
			delete parsedExpression2;
	}

}

std::string Expression::getExpression (const char * functionName) const
{
	if ( functionName[0] == 'x' )
		return expression2;
	else
		return expression1;
}

void Expression::setParsedExpression( FungParser * fp, const char * functionName )
{
	if ( functionName[0] == 'x' )
		parsedExpression2=fp;
	else
		parsedExpression=fp;
}

FungParser * Expression::getParsedExpression( const char * functionName ) const
{
	if ( functionName[0] == 'x' )
		return parsedExpression2;
	else
		return parsedExpression;
}

