/***************************************************************************
                          distancefunction.cpp  -  description
                             -------------------
    begin                : Mon Nov 11 2002
    copyright            : (C) 2002 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "distancefunction.h"

#include <cmath>

#include <qpainter.h>
#include <qobject.h>

DistanceFunction::DistanceFunction(BasicGraph *graph, int expressions) : MathFunction(graph,expressions)
{
}
DistanceFunction::~DistanceFunction()
{

}

void DistanceFunction::calculate_and_draw(QPainter *painter)
{
	double distance = sqrt( (arg1x-arg2x)*
				(arg1x-arg2x)+
				(arg1y-arg2y)*
				(arg1y-arg2y)
			      );
			      
	QString s = QString(QObject::tr("Distance = %1")).arg(distance);
	setResult(s);

	draw_stored(painter);
}

void DistanceFunction::draw_stored(QPainter *painter)
{
	painter->drawLine(lowerBounds.x(),lowerBounds.y(),upperBounds.x(),upperBounds.y());
}
