/***************************************************************************
                          mathfunctionimplementor.cpp  -  description
                             -------------------
    begin                : Thu Feb 27 2003
    copyright            : (C) 2003 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mathfunctionimplementor.h"

#include "mathfunction.h"

MathFunctionImplementor::MathFunctionImplementor()
{
}


MathFunctionImplementor::~MathFunctionImplementor()
{
	for (MathFunctionMap::const_iterator it = math_functions.begin(); it != math_functions.end(); it++)
		delete it->second;
}

void MathFunctionImplementor::addMathFunction( MathFunction *function, const char * id )
{
	math_functions.insert( math_functions.end(), MathFunctionPair(id,function) );
}

MathFunction * MathFunctionImplementor::getMathFunction( const char * id )
{
/*	MathFunctionMap::const_iterator pair = math_functions.find(id);
	if (pair != math_functions.end())
		return pair->second;
	else
		return 0;
*/
	for (MathFunctionMap::const_iterator it = math_functions.begin(); it != math_functions.end(); it++)
	{
		if ( it->first == id ) 
			return it->second;
	}

	return 0;
}

void MathFunctionImplementor::cancelMathFunctions()
{
	for (MathFunctionMap::const_iterator it = math_functions.begin(); it != math_functions.end(); it++)
		if (it->second->active()){it->second->cancel();}
}

void MathFunctionImplementor::drawMathFunctions(QPainter *p)
{
	for (MathFunctionMap::const_iterator it = math_functions.begin(); it != math_functions.end(); it++)
		if (it->second->active()){it->second->drawFunction(p);}
}

void MathFunctionImplementor::mathFunctionClick(QMouseEvent *e, double x, double y)
{
	for (MathFunctionMap::const_iterator it = math_functions.begin(); it != math_functions.end(); it++)
		if (it->second->active()){sendCustomClick(e,it->second,x,y);}

}

void MathFunctionImplementor::sendCustomClick(QMouseEvent *e, MathFunction *m, double x, double y)
{
	m->sendClick(e,x,y);
}


