/***************************************************************************
                          maximumfunction.cpp  -  description
                             -------------------
    begin                : Tue Nov 12 2002
    copyright            : (C) 2002 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "maximumfunction.h"

#include <qobject.h>
#include <qpoint.h>

#include "fungparser.h"

MaximumFunction::MaximumFunction(BasicGraph *graph, int expressions) : MathFunction(graph,expressions)
{
}

MaximumFunction::~MaximumFunction()
{
}

void MaximumFunction::calculate_and_draw(QPainter *painter)
{
	if ( lowerBounds.x() > upperBounds.x() ) //bounds check
	{
		QString s( QObject::tr("Invalid bounds") );
		setResult( s );
		return;
	}

	double x = toGraphXCoord(lowerBounds.x());
	double d[] = {x,animatorValue()};
	double y = expression->Eval(d);

	max_x_point = x;
	max_y_point = y;

	for (int i=lowerBounds.x()+1; i<=upperBounds.x(); i++)
	{
		x = toGraphXCoord(i);
		d[0]=x;
		y = expression->Eval(d);
		if (y > max_y_point)
		{
			max_y_point = y;
			max_x_point = x;
		}
	}
	QString s = QString(QObject::tr("Maximum = %1")).arg(max_y_point);
	setResult(s);

	draw_stored(painter);
}

void MaximumFunction::draw_stored(QPainter *painter)
{
	drawSelectedPoint(max_x_point,max_y_point, painter);
}
