/***************************************************************************
                          zerofunction.cpp  -  description
                             -------------------
    begin                : Tue Nov 19 2002
    copyright            : (C) 2002 by Fungmeista
    email                : mizunoami44@sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "zerofunction.h"

#include <qobject.h>
#include <qpoint.h>

#include "fungparser.h"
#include "fungmath.h"

ZeroFunction::ZeroFunction(BasicGraph *graph, int expressions) : MathFunction(graph,expressions)
{
	
}
ZeroFunction::~ZeroFunction()
{
}

void ZeroFunction::calculate_and_draw(QPainter *painter)
{
	double x,y,y_next,x_next;
	found = false;
	for (int i=lowerBounds.x(); i<upperBounds.x(); i++)
	{
		x = toGraphXCoord(i);
		double d[] = {x,animatorValue()};
		y = expression->Eval(d);

		x_next = toGraphXCoord(i+1);
		double d_next[] = {x_next,animatorValue()};
		y_next = expression->Eval(d_next);

		if ( ( y <= 0 && y_next >= 0 ) || ( y >= 0 && y_next <= 0 ) )
		{
			_x = ( ABS(y) < ABS(y_next) ) ? x : x_next; 
			found = true;
			break;
		} 
	}

	if (found)
	{
		QString s = QString(QObject::tr("Zero = ( %1, 0 )")).arg(_x);
		setResult(s);
	}
	else
	{
		QString s(QObject::tr("No zero"));
		setResult(s);
	}

	draw_stored(painter);
}

void ZeroFunction::draw_stored(QPainter *painter)
{
	if (found)
		drawSelectedPoint( _x, 0, painter );
}
