
#include "polarcoord.h"
#include "rectcoord.h"
#include <cmath>

PolarCoord::PolarCoord(double _radius, double _angle, int _angleMode, bool _bearing) : radius(_radius), angle(_angle), angleMode(_angleMode), bearingMode(_bearing)
{
}

RectCoord PolarCoord::toRectangular()
{
	double alphaX;
	double alphaY;
	if (angleMode == RADIANS)
	{
		alphaX = cos(angle) * radius;
		alphaY = sin(angle) * radius;
	}
	else
	{
		alphaX = cos(angle / (180 / PI)) * radius;
		alphaY = sin(angle / (180 / PI)) * radius;
	}
	return RectCoord(alphaX,alphaY);
}

double PolarCoord::x() const
{
	double alphaX;
	if (angleMode == RADIANS)
		alphaX = cos(angle) * radius;
	else
		alphaX = cos(angle / (180 / PI)) * radius;
	return alphaX;
}

double PolarCoord::y() const
{
	double alphaY;
	if (angleMode == RADIANS)
		alphaY = sin(angle) * radius;
	else
		alphaY = sin(angle / (180 / PI)) * radius;
	return alphaY;
}

