

#include "rectcoord.h"
#include "polarcoord.h"
#include <cmath>

RectCoord::RectCoord(double _x,double _y) : x(_x), y(_y)
{
}

PolarCoord RectCoord::toPolar(int mode, bool bearing)
{
	double angle;

	if (mode == DEGREES)
		angle = atan2(x,y)* (180 / PI);
	else
		angle = atan2(x,y);
				
	if (bearing)
	{
		double toReturn = 90 + (360 - angle);
		if (toReturn >= 360)
		{
			angle = toReturn - 360;
		}
		else
		{
			angle = toReturn;
		}
	}

	return PolarCoord(sqrt((x * x) + (y * y)),angle,mode);
}
