/***************************************************************************
                          sphericalcoord.cpp  -  description
                             -------------------
    begin                : Sat Nov 30 2002
    copyright            : (C) 2002 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <cmath>
 
#include "sphericalcoord.h"
#include "cartesian3dcoord.h"

SphericalCoord::SphericalCoord(double a, double p, double r) : azimuthal(a), polar(p), radial(r)
{
}

Cartesian3DCoord SphericalCoord::toCartesianCoord()
{
	double x,y,z;

	x = radial * cos(azimuthal) * sin(polar);
	y = radial * sin(azimuthal) * sin(polar);
	z = radial * cos(polar);

	return Cartesian3DCoord(x,y,z);
}
