/***************************************************************************
                          statinfo.cpp  -  description
                             -------------------
    begin                : Sun Jun 2 2002
    copyright            : (C) 2002-3 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "statinfo.h"

#include "fungmath.h"

int StatInfo::dcompare (const void * a, const void * b)
{
  return ( (int)*(double*)a - (int)*(double*)b );
}

double StatInfo::smaller(double a, double b)
{
	if (a < b)
		return a;
	else
		return b;
}

double StatInfo::bigger(double a, double b)
{
	if (a > b)
		return a;
	else
		return b;
}

double StatInfo::mean(std::vector<double> & xList)
{
	return sum(xList)/xList.size();
}

double StatInfo::median(std::vector<double> & xList)
{
	unsigned int items = xList.size();
	if (items % 2 == 0) //even number of items
		return (xList[(items+1)/2]+xList[(items-1)/2])/2;
	else
		return xList[(items+1)/2-1];
}

double StatInfo::mode(std::vector<double> & )
{
	return 0;
}

double StatInfo::range(std::vector<double> & xList)
{
	return xList[xList.size()-1] - xList[0];
}

double StatInfo::min(std::vector<double> & xList)
{
	return xList[0];
}

double StatInfo::max(std::vector<double> & xList)
{
	return xList[xList.size()-1];
}

double StatInfo::first_quartile(std::vector<double> & xList)
{
	unsigned int items = xList.size();
	if (items % 2 == 0) //even number of items
	{
		if (items % 4 == 0) //divisible by four
			return (xList[(items/4)]+xList[(items/4-1)])/2.0;
		else
			return xList[((items/2)-1)/2];
	}
	else
	{
		if ((items+1) % 4 == 0)
			return (xList[(items+1)/4]+xList[((items+1)/4-1)])/2.0;
		else
			return xList[((items+1)/2-1)/2];
	}

}

double StatInfo::third_quartile(std::vector<double> & xList)
{
	unsigned int items = xList.size();
	if (items % 2 == 0) //even number of items
	{
		if (items % 4 == 0) //divisible by four
			return (xList[(items/4)+items/2]+xList[(items/4-1)+items/2])/2.0;
		else
			return xList[((items/2)-1)/2+(items/2)];
	}
	else
	{
		if ((items+1) % 4 == 0)
			return (xList[(items+1)/4+(items+1)/2-1]+xList[((items+1)/4-1)+(items+1)/2-1])/2.0;     //<---needs fixin
		else
			return xList[((items+1)/2-1)/2+((items+1)/2-1)];
	}
}

double StatInfo::standard_dev(std::vector<double> & )
{
	return 0;
}

double StatInfo::sum(std::vector<double> & xList)
{
	unsigned int items = xList.size();
	double sum = 0;
	for (unsigned int i=0; i<items; i++)
	{
		sum += xList[i];
	}
	return sum;
}

double StatInfo::median_fit_line(std::vector<double> & , std::vector<double> &)
{
	return 0;
}

double StatInfo::correlation(std::vector<double> & , std::vector<double> & )
{
	return 0;
}

int StatInfo::frequency(std::vector<double> & list, double begin, double end)
{
	unsigned int elements = list.size();
	int frequency = 0;
	for (unsigned int i=0; i<elements; i++)
	{
		if (list[i] >= begin && list[i] < end)
			frequency++;
	}
	return frequency;
}

