/***************************************************************************
                          expressiongraphmain.cpp  -  description
                             -------------------
    begin                : Mon Jun 2 2003
    copyright            : (C) 2003 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "expressiongraphmain.h"

#include "expressiongraph.h"

ExpressionGraphMain::ExpressionGraphMain( QWidget* parent, const char* name ) : BasicGraphMain( parent, name )
{
	if ( !name )
	setName( "ExpressionGraphMain" );
}

void ExpressionGraphMain::setGraph( ExpressionGraph *e )
{
	graph = e;
	BasicGraphMain::setGraph(e);
}

void ExpressionGraphMain::play()
{
	graph->play();
}

void ExpressionGraphMain::stop()
{
	graph->stop();
}

void ExpressionGraphMain::pause()
{
	graph->pause();
}

void ExpressionGraphMain::save ( std::ofstream *fileOutput )
{
	BasicGraphMain::save( fileOutput );

	*fileOutput<<"animationMin= "<<graph->getAnimationMin()<<std::endl;
	*fileOutput<<"animationMax= "<<graph->getAnimationMax()<<std::endl;
	*fileOutput<<"animationStep= "<<graph->getAnimationStep()<<std::endl;
	*fileOutput<<"animationSpeed= "<<graph->getAnimationSpeed()<<std::endl;
	*fileOutput<<"animatorValue= "<<graph->animatorValue()<<std::endl;
}

void ExpressionGraphMain::load ( char *key, char *value )
{
	BasicGraphMain::load( key, value );

	if (strcmp(key,"drawConnected=") == 0)
	{
		bool show;
		if ( strcmp( value,"0" ) == 0 )
			show = false;
		else
			show = true;
		graph->setDrawConnected(show);
	}
	else if (strcmp(key,"trace=") == 0)
	{
		bool show;
		if ( strcmp( value,"0" ) == 0 )
			show = false;
		else
			show = true;
		graph->setTrace(show);
	}
	else if (strcmp(key,"animationMin=") == 0)
	{
		graph->setAnimationMin(QString(value).toDouble());
	}
	else if (strcmp(key,"animationMax=") == 0)
	{
		graph->setAnimationMax(QString(value).toDouble());
	}
	else if (strcmp(key,"animationStep=") == 0)
	{
		graph->setAnimationStep(QString(value).toDouble());
	}
	else if (strcmp(key,"animationSpeed=") == 0)
	{
		graph->setAnimationSpeed(QString(value).toInt());
	}
	else if (strcmp(key,"animatorValue=") == 0)
	{
		graph->setAnimationFrame(QString(value).toDouble());
	}
}

