/***************************************************************************
                          glbasicgraphmain.h  -  description
                             -------------------
    begin                : Mon Feb 17 2003
    copyright            : (C) 2003 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GLBASICGRAPHMAIN_H
#define GLBASICGRAPHMAIN_H

#include <qvariant.h>
#include "commongraphmain.h"

class GLGraphEvent;
class GLBasicGraph;
class GLExpressionGraph;

class GLBasicGraphMain : public CommonGraphMain
{
	Q_OBJECT

	public:
		GLBasicGraphMain( QWidget* parent = 0, const char* name = 0 );
		~GLBasicGraphMain();
		
		GLBasicGraph* getGraph(){return _graph;}

	public slots:
		//virtual void sendExpression();
		//virtual void dimensionsChanged( GraphEvent & e );
		//virtual void setExpression( QString & s );
		void setXMin( const QString & s );
		void setXMax( const QString & s );
		//virtual void setXScale( const QString & s );
		void setYMin( const QString & s );
		void setYMax( const QString & s );
		//virtual void setYScale( const QString & s );
		void setZMin( const QString & s );
		void setZMax( const QString & s );
		void setPolarEye( const QString & s );
		void setAzimuthalEye( const QString & s );
		void removeExpression();
		void graphRotated( const GLGraphEvent &event );
		void dimensionsChanged( const GLGraphEvent & e );
		//virtual void setZScale( const QString & s );
	//virtual void showOptions( bool show );
                
		virtual void load ( char *key, char *value, GLExpressionGraph * );
		virtual void save ( std::ofstream * fileOutput );
                                                                                
	protected:
        	void setGraph( GLBasicGraph *b ){ _graph = b; }
                
		//XLineEdit *xMinField;
		//XLineEdit *yMinField;
		//XLineEdit *xMaxField;
		//XLineEdit *yMaxField;
		//XLineEdit *xScaleField;
		//XLineEdit *yScaleField;
		
	private:
		GLBasicGraph * _graph;
};

#endif // GLBASICGRAPHMAIN_H
