
/***************************************************************************
                          commongraphmain.cpp  -  description
                             -------------------
    begin                : Mon Feb 17 2003
    copyright            : (C) 2003 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "commongraphmain.h"

#include <qbutton.h>
#include <qframe.h>

// used for status bar
#include <qlabel.h>
#include <qapplication.h>
#include <qmainwindow.h>
#include <qstatusbar.h>

CommonGraphMain::CommonGraphMain(QWidget *parent, const char *name, WFlags fl) : QWidget(parent, name, fl)
{
}

CommonGraphMain::~CommonGraphMain()
{
}

void CommonGraphMain::setTextColor( const char * name, const QColor & color)
{
		QWidget *obj = static_cast<QWidget*>(parent()->child(name));
		
		QPalette p = obj->palette();
		p.setColor( QColorGroup::Text, color );

		obj->setPalette(p);
}

/** This assumes that the button to toggle the controls is named ToggleControlsButton and the frame to hide is 
 *  named ControlsFrame.
 */
void CommonGraphMain::showOptions(bool show)
{
	(dynamic_cast<QButton*>(parent()->child("ToggleControlsButton")))->setText( QString( tr("Controls %1") ).arg( (show) ? "<<" : ">>" ) );
	
	QFrame *controlsFrame = dynamic_cast<QFrame*>(parent()->child("ControlsFrame"));
	(show) ? controlsFrame->show() : controlsFrame->hide();

	if (isMaximized())
	{
		QWidget *w = parentWidget()->parentWidget()->parentWidget()->parentWidget();
		w->resize( w->width(),(show) ? w->height()+controlsFrame->height() : w->height()-controlsFrame->height() );
	}
	else
		resize( width(),(show) ? height()+controlsFrame->height() : height()-controlsFrame->height() );
}

void CommonGraphMain::updateStatusBar( const QString & first, const QString & second , const QString & third)
{
	QStatusBar *status = (dynamic_cast<QMainWindow*>(qApp->mainWidget())) ? dynamic_cast<QMainWindow*>(qApp->mainWidget())->statusBar() : 0;

	if ( status )
	{
		#if ( (QT_VERSION & 0xFF0000) >= 3 && (QT_VERSION & 0x00FF00) >= 1 ) //not available unless have QT >= 3.1
		QLabel *label1 = dynamic_cast<QLabel*>(status->child("label1"));
		label1->setText( first );
        
		QLabel *label2 = dynamic_cast<QLabel*>(status->child("label2"));
		label2->setText( second );
		
		QLabel *label3 = dynamic_cast<QLabel*>(status->child("label3"));
		label3->setText( third );
		#else
		status->message(first+" "+second+" "+third);
		#endif
	}
}

void CommonGraphMain::setMainStatusMsg( const QString & s )
{
	QMainWindow *main = dynamic_cast<QMainWindow*>(qApp->mainWidget());
	QStatusBar *status = (main) ? main->statusBar() : 0;

	if ( status )
	{
		//#if ( (QT_VERSION & 0xFF0000) >= 3 && (QT_VERSION & 0x00FF00) >= 1 ) //not available unless have QT >= 3.1
		//QLabel *label = dynamic_cast<QLabel*>(status->child("standard"));
		//label->setText( tr(s) );
		//#else
		status->message( tr(s),2000);
		//#endif
	}
}

