/***************************************************************************
                          commongraphmain.h  -  description
                             -------------------
    begin                : Mon Feb 17 2003
    copyright            : (C) 2003 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COMMONGRAPHMAIN_H
#define COMMONGRAPHMAIN_H

#include <qwidget.h>

#include <fstream>

class CommonGraphMain : public QWidget
{
	Q_OBJECT

	public:
		CommonGraphMain( QWidget *parent, const char *name, WFlags fl = Qt::WDestructiveClose );
		~CommonGraphMain();

		virtual void load ( std::ifstream & fileInput ) = 0;
		virtual void save ( std::ofstream * fileOutput ) = 0;

		virtual void setStatusBarX( const QString & ){}
		virtual void setStatusBarY( const QString & ){}
		virtual void setStatusBarOther( const QString & ){}
		virtual void setStatusBarStandard( const QString & ){}

	public slots:
		void updateStatusBar( const QString &, const QString &, const QString & );

	protected:
		void setTextColor( const char *, const QColor & );
	
	protected slots:
		virtual void showOptions( bool show );
		void setMainStatusMsg( const QString & );
};

#endif
