/***************************************************************************
                          fungcolorbutton.cpp  -  description
                             -------------------
    begin                : Thu Nov 28 2002
    copyright            : (C) 2002 by Fungmeista
    email                : mizunoami44@sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qcolordialog.h>
#include <qpainter.h>

#include "fungcolorbutton.h"

FungColorButton::FungColorButton( QWidget *parent, const char *name, const QColor & color ) : QPushButton(parent,name), currentColor(color)
{
	p = QPixmap(width()/2, height()/2);
	setColor(currentColor);
}

void FungColorButton::mouseReleaseEvent(QMouseEvent *e)
{
	QPushButton::mouseReleaseEvent(e);

	if (hasMouse())
	{
		QColor color = QColorDialog::getColor();
		if (color.isValid())
			setColor(color);
	}
}

void FungColorButton::setColor(const QColor &color)
{
	currentColor = color;

	p.fill(currentColor);
	QPainter painter(&p);
	painter.drawRect( 0, 0, p.width(), p.height() );
	setPixmap(p);
}

