/***************************************************************************
                          fungcolorbutton.h  -  description
                             -------------------
    begin                : Thu Nov 28 2002
    copyright            : (C) 2002-03 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FUNGCOLORBUTTON_H
#define FUNGCOLORBUTTON_H

#include <qpushbutton.h>

/**
  *@brief A button for selecting a color
  *@author Fungmeista

  * When clicked, a color choosing dialog appears and after selecting a color
  * the button is set to the selected color.
  */

class FungColorButton : public QPushButton
{
	Q_OBJECT

	public: 
		FungColorButton( QWidget *parent=0, const char *name=0, const QColor & color = Qt::white );

		void setColor(const QColor &);
		inline QColor color(){return currentColor;}

	protected:
		void mouseReleaseEvent(QMouseEvent *);

	private:
		QColor currentColor;
		QPixmap p;
};

#endif
