/***************************************************************************
                          graph.cpp  -  description
                             -------------------
    begin                : Thu May 16 2002
    copyright            : (C) 2002 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                        *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qpixmap.h>
#include <qworkspace.h>

#include "graph.h"
#include "basicgraph.h"

Graph::~Graph()
{                 
}

QWidget* Graph::createGraph(QWidget *ws, int graphType)
{                     
	switch(graphType)
	{
		case FUNCTIONGRAPH:
		{
			FunctionGraphMain* f = new FunctionGraphMain(ws, "functiongraph");
			f->getGraph()->installMathFunctions();
			f->setIcon( QPixmap(functiongraph_xpm) );
			if ( ((QWorkspace*)ws)->windowList().isEmpty() )
				f->showMaximized();
			else
				f->show();
			return f;
			break;
		}
		case POLARGRAPH:
		{
			PolarGraphMain* po = new PolarGraphMain(ws, "polargraph");
			po->getGraph()->installMathFunctions();
			po->setIcon( QPixmap(polargraph_xpm) );
			if ( ((QWorkspace*)ws)->windowList().isEmpty() )
				po->showMaximized();
			else
				po->show();
			return po;
			break;
		}
		case PARAMETRICGRAPH:
		{
			ParametricGraphMain* p = new ParametricGraphMain(ws, "parametricgraph");
			p->getGraph()->installMathFunctions();
			p->setIcon( QPixmap(parametricgraph_xpm) );
			if ( ((QWorkspace*)ws)->windowList().isEmpty() )
				p->showMaximized();
			else
				p->show();
			return p;
			break;
		}
		case STATGRAPH:
		{
			StatPlotGraphMain* s = new StatPlotGraphMain(ws, "statplot");
			s->getGraph()->installMathFunctions();
			s->setIcon( QPixmap(statplot_xpm) );
			if ( ((QWorkspace*)ws)->windowList().isEmpty() )
				s->showMaximized();
			else
				s->show();
			return s;
			break;
		}
		case DENSITYPLOT:
		{
			DensityPlotMain* s = new DensityPlotMain(ws, "densityplot");
			s->getGraph()->installMathFunctions();
			s->setIcon( QPixmap(functiongraph_xpm) );
			if ( ((QWorkspace*)ws)->windowList().isEmpty() )
				s->showMaximized();
			else
				s->show();
			return s;
			break;
		}
		#ifdef GLGRAPH
		case GLFUNCTIONGRAPH:
		{
			GLFunctionGraphMain* s = new GLFunctionGraphMain(ws, "glfunctiongraph");
			s->setIcon( QPixmap(glfunctiongraph_xpm) );
			if ( ((QWorkspace*)ws)->windowList().isEmpty() )
				s->showMaximized();
			else
				s->show();
			return s;
			break;
		}
		case GLPOLARGRAPH:
		{
			GLPolarGraphMain* s = new GLPolarGraphMain(ws, "glpolargraph");
			s->setIcon( QPixmap(glpolargraph_xpm) );
			if ( ((QWorkspace*)ws)->windowList().isEmpty() )
				s->showMaximized();
			else
				s->show();
			return s;
			break;
		}
		case GLCYLINDRICALGRAPH:
		{
			GLCylindricalGraphMain* s = new GLCylindricalGraphMain(ws, "glcylindricalgraph");
			s->setIcon( QPixmap(glcylindricalgraph_xpm) );
			if ( ((QWorkspace*)ws)->windowList().isEmpty() )
				s->showMaximized();
			else
				s->show();
			return s;
			break;
		}
		#endif //GLGRAPH
	}
	return 0;
}

