/***************************************************************************
                          graph.h  -  description
                             -------------------
    begin                : Thu May 16 2002
    copyright            : (C) 2002 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GRAPH_H
#define GRAPH_H

#include "icons.h"

#include "commongraphmain.h"

#include "functiongraphmain.h"
#include "parametricgraphmain.h"
#include "polargraphmain.h"
#include "statplotgraphmain.h"
#include "densityplotmain.h"

#ifdef GLGRAPH
#include "glfunctiongraphmain.h"
#include "glpolargraphmain.h"
#include "glcylindricalgraphmain.h"
#endif //GLGRAPH

class QWidget;

/**
 * \author Fungmeista
 * \brief Adds a graph of the type specified to the given workspace and is a namespace for graph types
 */
class Graph
{
	public: 
		Graph(){}
		~Graph();
		static QWidget* createGraph(QWidget*,int);

		static const int FUNCTIONGRAPH = 0;
		static const int POLARGRAPH = 1;
		static const int PARAMETRICGRAPH = 2;
		static const int STATGRAPH = 3;
		static const int DENSITYPLOT = 4;
		#ifdef GLGRAPH
		static const int GLFUNCTIONGRAPH = 5;
		static const int GLPOLARGRAPH = 6;
		static const int GLCYLINDRICALGRAPH = 7;
		static const int GLPARAMETRICGRAPH = 8;
		#endif //GLGRAPH
};

#endif
