/***************************************************************************
                          graphtypeinfo.h  -  description
                             -------------------
    begin                : Sun Dec 1 2002
    copyright            : (C) 2002 by Fungmeista
    email                : mizunoami44@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifdef GLGRAPH
	#define NUM_TYPES 8
#else
	#define NUM_TYPES 5
#endif
const char * info[NUM_TYPES] = {
	QT_TRANSLATE_NOOP(
	"NewGraphDialog",
	"<center><b>Function Graph</b></center><hr>"
	"Create graphs of explicit functions with the "
	"variables \"x\" an \"y\".  This type of graph "
	"shows the value of the dependent variable \"y\" "
	"with respect to the independent variable \"x\". <br><br>"
	"Examples:"
	"<ul>"
	"<li>y(x)=sin(x)</li>"
	"<li>y(x)=1/x</li>"
	"</ul>"
	),

	QT_TRANSLATE_NOOP(
	"NewGraphDialog",
	"<center><b>Polar Graph</b></center><hr>"
	"Graphs the radial (r) with respect to the angular coordinate, t (theta). "
	"The radial is the distance from the origin, and the angular coordinate "
	"is the angle of rotation from the x-axis. <br><br>"
	"Examples:"
	"<ul>"
	"<li>r(t)=cos(t)</li>"
	"<li>r(t)=5</li>"
	"</ul>"
	),

	QT_TRANSLATE_NOOP(
	"NewGraphDialog",
	"<center><b>Parametric Graph</b></center><hr>"
	"Graphs a set of quantities as functions of independent variables: x and y. <br><br>"
	"Examples:"
	"<ul>"
	"<li>x(t)=sin(t)<br>y(t)=cos(t)</li>"
	"<li>x(t)=t^2<br>y(t)=1/t</li>"
	"</ul>"
	),

	QT_TRANSLATE_NOOP(
	"NewGraphDialog",
	"<center><b>Stat Plot Graph</b></center><hr>"
	"Plot data as a box-and-whisker plot, frequency distribution bar graph, "
	"or a scatter plot."
	),
        
	QT_TRANSLATE_NOOP(
	"NewGraphDialog",
	"<center><b>Density Plot</b></center><hr>"
	"Plots the z coordinate of an expression in terms of x and y on an x-y coordinate "
	"as brightness."
	)        

	#ifdef GLGRAPH
	,QT_TRANSLATE_NOOP(
	"NewGraphDialog",
	"<center><b>3D Function Graph</b></center><hr>"
	"Examples:"
	"<ul>"
	"<li>z(x,y)=sin(x)*x+cos(y)*y</li>"
	"<li>z(x,y)=1/x+ln(y)</li>"
	"</ul>"
	),

	QT_TRANSLATE_NOOP(
	"NewGraphDialog",
	"<center><b>3D Polar Graph</b></center><hr>"
	"Graphs the radial(r) with respect to the azimuthal(a) and polar(p) coordinate.<br><br>"
	"Examples:"
	"<ul>"
	"<li>r(a,p)=sin(p)*a</li>"
	"<li>r(a,p)=p/a</li>"
	"</ul>"
	),

	QT_TRANSLATE_NOOP(
	"NewGraphDialog",
	"<center><b>3D Cylindrical Graph</b></center><hr>"
	"Graph explicit 3D cylindrical graphs.  Graphs the z coordinate with respect to r (radius) and t (theta). "
	"Radius is the distance from the origin and theta is the angular coordinate, which represents the angle "
	"of rotation in the xy plane from the x-axis. \n\n"
	"Examples:"
	"<ul>"
	"<li>z(r,t)=r*t</li>"
	"<li>z(r,t)=5</li>"
	"</ul>"
	)
	#endif
	};
